/****************************************************************************
 *
 *                               IBM INC.
 *
 *                           PROPRIETARY DATA
 *
 * Licensed Material - Property Of IBM
 *
 * "Restricted Materails of IBM"
 *
 * IBM Informix Client SDK
 *
 * (c)  Copyright IBM Corporation 2002. All rights reserved.
 *
 ****************************************************************************
 */


//  Title: csql.cpp
//
//  Description:
//	 Submit simple query example

#include <iostream.h>
#include <it.h>

int
main(int, char *)
{
    // Make a connection using defaults
    ITConnection conn;                                              // 1 begin
    conn.Open();                                                    // 1 end

    // Create a query object
    ITQuery query(conn);                                            // 2 begin
                                                                    // 2 end
    char qtext[1024];
    
    cout << "> ";

    // Read rows from standard input
    while (cin.getline(qtext, sizeof(qtext)))                       // 3 begin
    {                                                               // 3 end
        if (!query.ExecForIteration(qtext))                         // 4 begin
        {                                                           // 4 end
            cout << "Could not execute query: " << qtext << endl;
        }                                                           // 4 begin
                                                                    // 4 end
        else
        {
            ITRow *comp;                                            // 5 begin
            int rowcount = 0;
            while ((comp = query.NextRow()) != NULL)
            {                                                       // 5 end
                rowcount++;
                cout << comp->Printable() << endl;                  // 6 begin
                                                                    // 6 end
                comp->Release();                                    // 7 begin
                                                                    // 7 end
            }                                                       // 5 begin
                                                                    // 5 end
            cout << rowcount << " rows received, Command:"
                 << query.Command() << endl;
        }
	if (query.Error())
	    cout << "Error: " << query.ErrorText() << endl;
        cout << "> ";
    }                                                               // 3 begin
                                                                    // 3 end
    conn.Close();                                                   // 8 begin
                                                                    // 8 end
    cout << endl;

    return 0;
}

