/****************************************************************************
 *
 *                               IBM INC.
 *
 *                           PROPRIETARY DATA
 *
 * Licensed Material - Property Of IBM
 *
 * "Restricted Materails of IBM"
 *
 * IBM Informix Client SDK
 *
 * (c)  Copyright IBM Corporation 2002. All rights reserved.
 *
 ****************************************************************************
 */


//	Title: deldrv.cpp
//  Description:
//	 driver for delegate test.

#include <iostream.h>
#include <it.h>
extern "C"
{
#include <mitrace.h>
}

int
main(int argc, char *argv[])
{
    if (argc == 2)
    {
        mi_trace(argv[1]);
    }
    
    ITConnection conn;
    conn.Open();

    ITQuery query( conn );
    query.ExecForIteration( "select bitarraycol from bitarraytab;");

    ITRow *row;
    while ( row = query.NextRow() )
        {
        ITValue *aval = row->Column( 0 );
        cout << "Bitarray as integer: " << aval->Printable() << endl;

        ITContainCvt *accvt;
        aval->QueryInterface( ITContainCvtIID, (void **)&accvt );
        for( int i = 0; i < accvt->NumItems(); i++ )
            {
            int ival;
            accvt->ConvertTo( i, ival );            
            cout << "Bitarray bit " << i << " value " << ival << endl;
            }
        accvt->Release();
        aval->Release();
        row->Release();
        }
    return 0;
}

