/****************************************************************************
 *
 *                               IBM INC.
 *
 *                           PROPRIETARY DATA
 *
 * Licensed Material - Property Of IBM
 *
 * "Restricted Materails of IBM"
 *
 * IBM Informix Client SDK
 *
 * (c)  Copyright IBM Corporation 2002. All rights reserved.
 *
 ****************************************************************************
 */


//  Title: fsexamp1.cpp
//  Description:
//	  Example of Container interface

#include <iostream.h>
#include <it.h>

int
main(int, char **)
{
    // Make a connection using defaults
    ITConnection conn;
    conn.Open();

    // Check the error
    if (conn.Error())
    {
	// some error making connection
	cerr << conn.ErrorText() << endl;
	return 1;
    }

    ITQuery q(conn);                                                // 1 begin
                                                                    // 1 end
    ITRow *row =                                                    // 2 begin
        q.ExecOneRow("select unique count(*) from informix.systables where tabname in ('systables', 'syscolumns', 'sysviews');");

    if (q.Error())
        {
	    // some error processing row
	    cerr << q.ErrorText() << endl;
	    return 1;
        }                                                           // 2 end

    int numtabs;                                                    // 3 begin
    ITContainerIter(row) >> numtabs;                                // 3 end
    cout << "Number of Informix Tables: " << numtabs << endl;

    row->Release();                                                 // 4 begin
                                                                    // 4 end
    return 0;
}
