/****************************************************************************
 *
 *                               IBM INC.
 *
 *                           PROPRIETARY DATA
 *
 * Licensed Material - Property Of IBM
 *
 * "Restricted Materails of IBM"
 *
 * IBM Informix Client SDK
 *
 * (c)  Copyright IBM Corporation 2002. All rights reserved.
 *
 ****************************************************************************
 */


//  Filename: routine.cpp
//
//  Description:  
//             	Creates the function mysum(int,int) which returns int,
//				and tries to execute this function by passing appropriate
//				argument to it, and checks it's return value.
//
//////////////////////////////////////////////////////////////////////////////

#include <iostream.h>
#include <stdio.h>
#include <it.h>

int
main(int argc, char *argv[])
{
	ITDBInfo dbinfo;
	ITConnection conn(dbinfo);	

	ITQuery q(conn);
	q.ExecForStatus("drop function mysum(int,int);");
	q.ExecForStatus("create function mysum(i int, j int) returns int; "
                       "  return (i + j); "
                       " end function;" );

	ITRoutineManager routine(conn);                                 // 1 begin
                                                                    // 1 end
 
	ITBool bret = routine.GetRoutine("function mysum(int,int)");      // 2 begin
                                                                    // 2 end
	cout << "GetRoutine returned  " << (bret ? "TRUE " : "FALSE ") << endl;

	ITValue *val, *val1, *val2; 
	val = routine.Param(0);                                         // 3 begin
	val->FromPrintable("1");
	val->Release();
                                                                    // 3 end
	val1 = routine.Param(1);
	val1->FromPrintable("2");
	val1->Release();

	val2 = routine.ExecForValue();                                  // 4 begin
                                                                    // 4 end
	ITString resultval;
	if (val2)
	{
		cout << "Type of return value is " <<
			(routine.ResultType())->Name() << endl;
		resultval = val2->Printable();
        val2->Release();                                             // 5 begin
	}                                                               // 5 end
	cout << "Func returned the Value of " << resultval << endl;
	return 0;
}

