/****************************************************************************
 *
 *                               IBM INC.
 *
 *                           PROPRIETARY DATA
 *
 * Licensed Material - Property Of IBM
 *
 * "Restricted Materails of IBM"
 *
 * IBM Informix Client SDK
 *
 * (c)  Copyright IBM Corporation 2002. All rights reserved.
 *
 ****************************************************************************
 */
/*
   *int8add.ec *

   The following program obtains the sum of two INT8 type values.
*/

#include <stdio.h>

EXEC SQL include "int8.h";

char string1[] = "6";	
char string2[] = "99,999,999,999,999,999";
char string3[] = "9,199,999,999,999,999,999";
char result[41];

main()
{
    mint x;
    ifx_int8_t num1, num2, num3, sum;

    printf("INT8 Sample ESQL Program running.\n\n");

    if (x = ifx_int8cvasc(string1, strlen(string1), &num1))
		{
		printf("Error %d in converting string1 to INT8\n", x);
		exit(1);
		}
    if (x = ifx_int8cvasc(string2, strlen(string2), &num2))
		{
		printf("Error %d in converting string2 to INT8\n", x);
		exit(1);
		}
    if (x = ifx_int8add(&num1, &num2, &sum))    /* adding the first two INT8s */
        {
        printf("Error %d in adding INT8s\n", x);
        exit(1);
        }
    if (x = ifx_int8toasc(&sum, result, sizeof(result)))
        {
        printf("Error %d in converting INT8 result to string\n", x);
        exit(1);
        }
    result[40] = '\0';
    printf("\t%s + %s = %s\n", string1, string2, result); /* display result */
    
    /* attempt to convert to INT8 value that is too large*/

    printf("/*Add %s + %s to show error result*/\n", string2, string3); /* display result */
    if (x = ifx_int8cvasc(string3, strlen(string3), &num3))  
		{
		printf("Error %d in converting string3 to INT8\n", x);
		exit(1);
		}
	if (x = ifx_int8add(&num2, &num3, &sum))
        { 
        printf("\tError %d in adding INT8s\n", x); 
        exit (1);
        }
    if (x = ifx_int8toasc(&sum, result, sizeof(result)))
        {
        printf("Error %d in converting INT8 result to string\n", x);
        exit(1);
        } 
    result[40] = '\0';
    printf("\t%s + %s = %s\n", string2, string3, result); /* display result */

    printf("\nINT8 Sample Program over.\n\n");
    exit(0);
}
